#
#    forest/backend.py implements storage of the trees, branches, and leaves
#    Copyright (C) 2002  Michael Urman
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

"""
backend.py

Implements the base class backend for the forest message system.  It does no
security checking, assuming that the front-end (server) has done it already.
"""

#import forest   # load configuration

class error(Exception):
    pass

class backend:

    """backend provides all the services the front-end (server) needs."""

    def __init__(self): pass

    # get info
    def get_trees(self): pass
    def count_tree_branches(self, tree): pass
    def get_tree_branches(self, tree): pass
    def count_tree_branch_posts(self, tree, branch): pass
    def get_tree_branch_posts(self, tree, branch): pass
    def read_tree_branch_post(self, tree, branch, post): pass

    # set info
    def set_tree_blurb(self, tree, blurb): pass
    def set_tree_attention_blurb(self, tree, blurb): pass

    # write info
    def make_tree(self, tree):
    def make_post(self, tree, branch, post): pass
    def make_branch_post(self, tree, post, blurb): pass

    # hide info
    def hide_tree(self, tree): pass
    def hide_tree_branch(self, tree, branch): pass
    def hide_tree_branch_post(self, tree, branch, post): pass

    # delete info
    def delete_tree(self, tree): pass
    def delete_tree_branch(self, tree, branch): pass
    def delete_tree_branch_post(self, tree, branch, post): pass

    # privileges
    def set_global_priv(self, priv): pass
    def set_tree_priv(self, tree, priv): pass
    def read_global_priv(self, user): pass
    def read_tree_priv(self, tree, user): pass

    # high-level; implement lower for optimization if desired
    def copy_tree(self, tree, dest, quote=0): pass
    def copy_tree_branch(self, tree, dest, quote=0): pass
